{{- /* ------------------------------------------------------------------ */ -}}
{{- /* Init variables                                                     */ -}}
{{- /* ------------------------------------------------------------------ */ -}}
{{- $buildOptions := partial "return/build_options" -}}

{{- $opts := index $buildOptions "opts" -}}
{{- $optsEs5 := index $buildOptions "optsEs5" -}}
{{- $babelOpts := index $buildOptions "babelOpts" -}}

{{- $lang := $.Site.LanguageCode -}}


{{- /* ------------------------------------------------------------------ */ -}}
{{- /* TODO: Specific JS for current page (?)                             */ -}}
{{- /*   -> could be placed in assets/js/pages/…                          */ -}}
{{- /* ------------------------------------------------------------------ */ -}}
{{- /* $curPagePath := print (urls.Parse .Page.Permalink).Path            */ -}}
{{- /* printf "%#v" $curPagePath                                          */ -}}


{{- /* ------------------------------------------------------------------ */ -}}
{{- /* WARNING! We assume that dev environment uses a modern browser      */ -}}
{{- /*   --> speeds up the feedback loop while developping                */ -}}
{{- /* ------------------------------------------------------------------ */ -}}
{{- if hugo.IsProduction -}}

	{{- if .Param "activate_web_components" -}}

		{{- /* -------------------------------------------------------------- */ -}}
		{{- /* Webcomponents loader: injects the polyfill only if necessary   */ -}}
		{{- /* Note: webcomponents-loader is not a module, we need to import  */ -}}
		{{- /* it "the old way". See module.toml for the node_modules mount   */ -}}
		{{- /* Trick here to minify and keep the same script name with ".js"  */ -}}
		{{- /* instead of ".min.js" (mandatory for this loader to work)       */ -}}
		{{- /* -------------------------------------------------------------- */ -}}
		{{- $wcLoader_js := slice (resources.Get "@webcomponents/webcomponentsjs/webcomponents-loader.js" | resources.Minify) | resources.Concat "@webcomponents/webcomponentsjs/webcomponents-loader.js" -}}
		<script src="{{ $wcLoader_js.RelPermalink }}"></script>
	{{- end -}}

	{{- /* ---------------------------------------------------------------- */ -}}
	{{- /* Support old browsers: CSS variables, SVG images                  */ -}}
	{{- /* ---------------------------------------------------------------- */ -}}
	{{- $oldBrowsers_js := resources.Get "base-structure/js/old_browsers.js" | js.Build $opts -}}
	{{- $oldBrowsers_js = $oldBrowsers_js | babel $babelOpts -}}
	{{- $oldBrowsers_js = $oldBrowsers_js | resources.ExecuteAsTemplate (printf "%s/js/oldBrowsers.js" $lang ) . | fingerprint -}}
	<script nomodule src="{{ $oldBrowsers_js.RelPermalink }}" defer></script>
{{- end -}}


{{- /* ------------------------------------------------------------------ */ -}}
{{- /* Bundle JS for new browsers                                         */ -}}
{{- /* Note: for old browsers, bundle is included at the end of <body>    */ -}}
{{- /* See $mainEs5_js in `layouts/partial/body_script_js_end.html`       */ -}}
{{- /* ------------------------------------------------------------------ */ -}}
{{- $bundleJsScratch := newScratch -}}

{{- /* 1. Main JS ------------------------------------------------------- */ -}}
{{- $main_js := resources.Get "js/index.js" | js.Build $opts -}}
{{- $main_js = $main_js | resources.ExecuteAsTemplate (printf "%s/js/index.js" $lang ) . -}}
{{- $bundleJsScratch.Add "bundleJs" (slice $main_js) -}}

{{- /* 2. Webcomponents — if `activate_web_components` is true ---------- */ -}}
{{- if .Param "activate_web_components" -}}
	{{- $components_js := resources.Get "base-structure/js/components.js" | js.Build $opts -}}
	{{- $bundleJsScratch.Add "bundleJs" $components_js -}}
{{- end -}}

{{- /* 3. Bundle — language specific ------------------------------------ */ -}}
{{- $bundle := $bundleJsScratch.Get "bundleJs" | resources.Concat (printf "%s/js/bundle.js" $lang ) | fingerprint -}}
<script type="module" src="{{ $bundle.RelPermalink }}"></script>
